> For the complete documentation index, see [llms.txt](https://docs.fortifiedid.se/access/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.fortifiedid.se/access/key-components/authenticators/credential-validators/freja-e-id/with-user-input.md).

# With user input

This authenticator expects users to input an identifier. Based on the configuration it can be e-mail, personnummer, phone number, or organizational identifier.

## Configuration

Based on the Freja e-ID documentation found here:

[Freja eID Relying Party Developers' Documentation](https://frejaeid.atlassian.net/wiki/spaces/DOC/pages/2162826/REST+API+Documentation)

{% hint style="info" %}
**Authenticator type:** `FrejaWithUserInput`
{% endhint %}

Common Authenticator configuration can be found [here](/access/key-components/authenticators/common-configuration.md).

{% tabs %}
{% tab title="Properties" %}

<table data-full-width="true"><thead><tr><th>Name</th><th>Description</th><th>Default value</th><th data-type="checkbox">Mandatory</th></tr></thead><tbody><tr><td><code>internal_http_destination</code></td><td>ID of the internal http client used to talk with backend.</td><td>N/A</td><td>true</td></tr><tr><td><code>mode</code></td><td>Four modes are possible: <code>"prod_personal"</code>, <code>"test_personal"</code> , <code>"prod_org"</code> &#x26; <code>"test_org"</code> <em>.</em> Depending on the mode, the URL used to talk to Freja backen differs.</td><td><code>"prod_personal"</code></td><td>true</td></tr><tr><td><code>userInfoType</code></td><td>How to identify the user on the front end. Possible values are: <code>"PHONE"</code>, <code>"EMAIL"</code>, <code>"SSN"</code>, <code>"ORG_ID"</code></td><td><code>"SSN"</code></td><td>false</td></tr><tr><td><code>attributesToReturn</code></td><td>Array of attributes to return to the server after completed authentication. See allowed values in Freja documentation</td><td>N/A</td><td>true</td></tr><tr><td><code>minRegistrationLevel</code></td><td>Required registration level. Allowed values are <code>"BASIC"</code>, <code>"EXTENDED"</code> or <code>"PLUS"</code></td><td><code>"PLUS"</code></td><td>false</td></tr><tr><td><code>relyingPartyId</code></td><td>Value of the relying party ID to be used</td><td>N/A</td><td>false</td></tr><tr><td><code>custom_identifier</code></td><td>When logging events, the custom_identifier lets you tag the event.</td><td>N/A</td><td>false</td></tr><tr><td><code>webroot_dir</code></td><td>See common authenticator configuration</td><td>web/authenticator/freja/freja_with_user_input</td><td>false</td></tr></tbody></table>
{% endtab %}

{% tab title="Example" %}

```json
{
	"id": "frejauserinput",
	"type": "FrejaWithUserInput",
	"config": {
		"base_path": "/test/authn",
		"internal_http_destination": "freja",
		"webroot_dir": "web/authenticator/freja/freja_with_user_input",
		"userInfoType": "SSN",
		"attributesToReturn": [
			"BASIC_USER_INFO", "EMAIL_ADDRESS"
		],
		"minRegistrationLevel": "EXTENDED",
		"mode": "prod_personal"
	}
}
```

{% endtab %}
{% endtabs %}

{% hint style="warning" %}
Property *base\_path* should not contain the full path when used in conjunction with the [Selector](/access/key-components/authenticators/flow-control/selector.md), instead, the full URI will be handled by the selector. The full path will be *base\_path + / + id*.
{% endhint %}

## Logging

Apart from system logging, event logging is done when starting, completing, and failing a transaction.

Event ids are:

* WEB\_100005("Freja authentication started")
  * IDENTIFIER (user trace id)
  * SOURCE\_ADDRESS (ip address of device starting transaction)
  * CUSTOMER\_IDENTIFIER (if configured)
  * AUTHENTICATOR\_IDENTIFIER (id and display name)
* WEB\_100006("Freja authentication completed")
  * IDENTIFIER (user trace id)
  * SOURCE\_ADDRESS (ip address of the device used)
  * CUSTOMER\_IDENTIFIER (if configured)
  * AUTHENTICATOR\_IDENTIFIER (id and display name)
* WEB\_100008("Freja authentication canceled or expired")
  * IDENTIFIER (user trace id)
  * SOURCE\_ADDRESS (ip address of the device used)
  * CUSTOMER\_IDENTIFIER (if configured)
  * AUTHENTICATOR\_IDENTIFIER (id and display name)

## Data exposed to global state

After a user completes a transaction, the authenticator is marked as done. Data from the authentication response is then put into the global state replacing existing values:

* details
* givenName
* surName
* ssn
* co
* mail
* organisationIdIdentifier
* integratorSpecificUserId
* relyingPartyUserId
* registrationLevel
* loaLevel
* uniquePersonalIdentifier

Note that it is not guaranteed that all parameters hold value. The result varies depending on the configuration

## API

When communicating with the backend this describes the

### General requirements

Backend communications are made using AJAX and the HTTP PUT method. Every request need a Content-Type with the value of `application/json`*.*

### Getting state

Body must conform to the example below.

```json
{
    "type": "state"
}
```

### Starting an authentication

To start authentication send AJAX request containing the user's identifier, 12 digits.

```json
{
    "type": "start",
    "data": {
        "identifier": "<user_data>"
    }
}
```

### Cancel a request

A request can be canceled at any time. This is done by sending a cancel request.

```json
{
    "type": "cancel"
}
```

### Response from server

In general, you should expect a server response with http status code 200. Anything else is to be considered an error.

Response body will be in the form of a JSON object. Typically the response looks like:

```json
{
    "status": "ABOUT_TO_START",
    "frejaStatus": "", (optional)
    "authRef": "", (optional)
}
```

The property `"status"` will contain status.

### Possible status messages

One of the following status codes is returned based on the current state.

* ABOUT\_TO\_START
* PENDING
* COMPLETED
* FREJA\_ERROR
* ERROR

### Possible frejaStatus messages

One of the following frejaStatus codes is returned based on the current state.

* STARTED
* DELIVERED\_TO\_MOBILE
* CANCELED
* RP\_CANCELED
* EXPIRED
* APPROVED
* REJECTED
* UNKNOWN

## Data in authRef

Once the authentication process has started the identifier generated by the Freja-backed server is sent back to the client in parameter *authRef*.

## Translation keys

```json
{
  "freja.with_user_input.identifier": "Username",
  "freja.with_user_input.start_authentication": "Start authentication",
  "freja.with_user_input.open_app": "Open BankID app",
  "freja.with_user_input.app_opened": "BankID app opened",
  "freja.with_user_input.verify_authentication": "Verifify identification",
  "freja.with_user_input.authentication_verified": "Identification verified",
  "freja.with_user_input.redirecting": "Redirecting...",
  "freja.with_user_input.start_app": "Start your BankID app.",
  "freja.with_user_input.cancel": "Cancel",
  "freja.with_user_input.canceling": "Canceling...",
  "freja.with_user_input.ERROR": "Unknown error. Please try again.",
  "freja.with_user_input.UNKNOWN": "Unknown error. Please try again.",
  "freja.with_user_input.CANCELED": "Action cancelled. Please try again.",
  "freja.with_user_input.EXPIRED": "The Freja eID app is not responding. Please check that the program is started and that you have internet access.",
  "freja.with_user_input.REJECTED": "Authentication denied",
  "freja.with_user_input.RP_CANCELED": "Action cancelled. Please try again.",
  "freja.with_user_input.INTERRUPTED": "Action cancelled. Please try again.",
  "freja.with_user_input.API_ERROR": "Unknown error. Please try again.",
  "allow-cookies-body": "To save your language settings on this device you need to approve a language cookie.",
  "allow-cookies-button": "Approve language cookie",
  "authentication.help_text": "",
  "change_language": ""
}

```

```json
{
  "freja.with_user_input.identifier": "Användarnamn",
  "freja.with_user_input.start_authentication": "Starta verifiering",
  "freja.with_user_input.open_app": "Öppna Freja eID-appen",
  "freja.with_user_input.app_opened": "Freja eID-appen öppnad",
  "freja.with_user_input.verify_authentication": "Verifiera legitimering",
  "freja.with_user_input.authentication_verified": "Legitimeringen verifierad",
  "freja.with_user_input.redirecting": "Omdirigerar...",
  "freja.with_user_input.start_app": "Starta Freja eID-appen",
  "freja.with_user_input.cancel": "Avbryt",
  "freja.with_user_input.canceling": "Avbryter...",
  "freja.with_user_input.ERROR": "Okänt fel. Försök igen.",
  "freja.with_user_input.UNKNOWN": "Okänt fel. Försök igen.",
  "freja.with_user_input.CANCELED": "Åtgärden avbruten. Försök igen",
  "freja.with_user_input.EXPIRED": "Freja eID-appen svarar inte. Kontrollera att den är startad och att  du har internetanslutning.",
  "freja.with_user_input.REJECTED": "Legitimeringen nekad",
  "freja.with_user_input.RP_CANCELED": "Åtgärden avbruten. Försök igen",
  "freja.with_user_input.INTERRUPTED": "Åtgärden avbruten. Försök igen",
  "freja.with_user_input.API_ERROR": "Okänt fel. Försök igen.",
  "allow-cookies-body": "Vill du spara dina språkinställningar på denna enhet behövs ett godkännande av  språk-cookie.",
  "allow-cookies-button": "Godkänn språk-cookie",
  "authentication.help_text": "",
  "change_language": ""
}

```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.fortifiedid.se/access/key-components/authenticators/credential-validators/freja-e-id/with-user-input.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
